/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Florian Zinggeler
 *   Co-authors:
 *      ...
 *
 */

/**
    @file DodgeRaceShip.h
    @brief Declaration of the DodgeRaceShip class.
*/

#ifndef _PacmanGelb_H__
#define _PacmanGelb_H__


#include "pacman/PacmanPrereqs.h"

#include "core/XMLPort.h"
#include "worldentities/pawns/SpaceShip.h"
#include "graphics/Camera.h"


namespace orxonox
{
    class _PacmanExport PacmanGelb : public SpaceShip
    {
        public:
            PacmanGelb(Context* context);

            virtual void tick(float dt);

            //no rotation
            virtual void rotateYaw(const Vector2& value) override{
                this->localAngularAcceleration_.setY(this->localAngularAcceleration_.y() + value.x);

                Pawn::rotateYaw(value);

                // This function call adds a lift to the ship when it is rotating to make it's movement more "realistic" and enhance the feeling.
                if (this->getLocalVelocity().z < 0 && std::abs(this->getLocalVelocity().z) < stallSpeed_)
                this->moveRightLeft(-lift_ / 5.0f * value * sqrt(std::abs(this->getLocalVelocity().y)));
            };
            virtual void rotatePitch(const Vector2& value) override{};

        private:
            Vector3 actuelposition;
            Quaternion actuelorient;
       
    };
}

#endif
